=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpRpmClient
  class ContentModulemdsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a modulemd
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param relative_path [String] Path where the artifact is located relative to distributions base_path
    # @param name [String] Modulemd name.
    # @param stream [String] Stream name.
    # @param version [String] Modulemd version.
    # @param context [String] Modulemd context.
    # @param arch [String] Modulemd architecture.
    # @param artifacts [Object] Modulemd artifacts.
    # @param dependencies [Object] Modulemd dependencies.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [File] :file An uploaded file that may be turned into the artifact of the content unit.
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @option opts [String] :upload An uncommitted upload that may be turned into the artifact of the content unit.
    # @option opts [Boolean] :static_context Modulemd static-context flag.
    # @option opts [Array<String>] :packages Modulemd artifacts&#39; packages.
    # @return [AsyncOperationResponse]
    def create(relative_path, name, stream, version, context, arch, artifacts, dependencies, opts = {})
      data, _status_code, _headers = create_with_http_info(relative_path, name, stream, version, context, arch, artifacts, dependencies, opts)
      data
    end

    # Create a modulemd
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param relative_path [String] Path where the artifact is located relative to distributions base_path
    # @param name [String] Modulemd name.
    # @param stream [String] Stream name.
    # @param version [String] Modulemd version.
    # @param context [String] Modulemd context.
    # @param arch [String] Modulemd architecture.
    # @param artifacts [Object] Modulemd artifacts.
    # @param dependencies [Object] Modulemd dependencies.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [File] :file An uploaded file that may be turned into the artifact of the content unit.
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @option opts [String] :upload An uncommitted upload that may be turned into the artifact of the content unit.
    # @option opts [Boolean] :static_context Modulemd static-context flag.
    # @option opts [Array<String>] :packages Modulemd artifacts&#39; packages.
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(relative_path, name, stream, version, context, arch, artifacts, dependencies, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentModulemdsApi.create ...'
      end
      # verify the required parameter 'relative_path' is set
      if @api_client.config.client_side_validation && relative_path.nil?
        fail ArgumentError, "Missing the required parameter 'relative_path' when calling ContentModulemdsApi.create"
      end
      if @api_client.config.client_side_validation && relative_path.to_s.length < 1
        fail ArgumentError, 'invalid value for "relative_path" when calling ContentModulemdsApi.create, the character length must be great than or equal to 1.'
      end

      # verify the required parameter 'name' is set
      if @api_client.config.client_side_validation && name.nil?
        fail ArgumentError, "Missing the required parameter 'name' when calling ContentModulemdsApi.create"
      end
      if @api_client.config.client_side_validation && name.to_s.length < 1
        fail ArgumentError, 'invalid value for "name" when calling ContentModulemdsApi.create, the character length must be great than or equal to 1.'
      end

      # verify the required parameter 'stream' is set
      if @api_client.config.client_side_validation && stream.nil?
        fail ArgumentError, "Missing the required parameter 'stream' when calling ContentModulemdsApi.create"
      end
      if @api_client.config.client_side_validation && stream.to_s.length < 1
        fail ArgumentError, 'invalid value for "stream" when calling ContentModulemdsApi.create, the character length must be great than or equal to 1.'
      end

      # verify the required parameter 'version' is set
      if @api_client.config.client_side_validation && version.nil?
        fail ArgumentError, "Missing the required parameter 'version' when calling ContentModulemdsApi.create"
      end
      if @api_client.config.client_side_validation && version.to_s.length < 1
        fail ArgumentError, 'invalid value for "version" when calling ContentModulemdsApi.create, the character length must be great than or equal to 1.'
      end

      # verify the required parameter 'context' is set
      if @api_client.config.client_side_validation && context.nil?
        fail ArgumentError, "Missing the required parameter 'context' when calling ContentModulemdsApi.create"
      end
      if @api_client.config.client_side_validation && context.to_s.length < 1
        fail ArgumentError, 'invalid value for "context" when calling ContentModulemdsApi.create, the character length must be great than or equal to 1.'
      end

      # verify the required parameter 'arch' is set
      if @api_client.config.client_side_validation && arch.nil?
        fail ArgumentError, "Missing the required parameter 'arch' when calling ContentModulemdsApi.create"
      end
      if @api_client.config.client_side_validation && arch.to_s.length < 1
        fail ArgumentError, 'invalid value for "arch" when calling ContentModulemdsApi.create, the character length must be great than or equal to 1.'
      end

      # resource path
      local_var_path = '/pulp/api/v3/content/rpm/modulemds/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['relative_path'] = relative_path
      form_params['name'] = name
      form_params['stream'] = stream
      form_params['version'] = version
      form_params['context'] = context
      form_params['arch'] = arch
      form_params['artifacts'] = artifacts
      form_params['dependencies'] = dependencies
      form_params['artifact'] = opts[:'artifact'] if !opts[:'artifact'].nil?
      form_params['file'] = opts[:'file'] if !opts[:'file'].nil?
      form_params['repository'] = opts[:'repository'] if !opts[:'repository'].nil?
      form_params['upload'] = opts[:'upload'] if !opts[:'upload'].nil?
      form_params['static_context'] = opts[:'static_context'] if !opts[:'static_context'].nil?
      form_params['packages'] = @api_client.build_collection_param(opts[:'packages'], :csv) if !opts[:'packages'].nil?

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentModulemdsApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List modulemds
    # ViewSet for Modulemd.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :sha256 
    # @option opts [String] :stream Filter results where stream matches value
    # @option opts [Array<String>] :stream__in Filter results where stream is in a comma-separated list of values
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedrpmModulemdResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List modulemds
    # ViewSet for Modulemd.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :sha256 
    # @option opts [String] :stream Filter results where stream matches value
    # @option opts [Array<String>] :stream__in Filter results where stream is in a comma-separated list of values
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedrpmModulemdResponseList, Integer, Hash)>] PaginatedrpmModulemdResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentModulemdsApi.list ...'
      end
      allowable_values = ["-_artifacts", "-arch", "-artifacts", "-content_ptr", "-contentartifact", "-context", "-dependencies", "-group_roles", "-name", "-packages", "-pk", "-pulp_created", "-pulp_id", "-pulp_labels", "-pulp_last_updated", "-pulp_type", "-repositories", "-static_context", "-stream", "-timestamp_of_interest", "-upstream_id", "-user_roles", "-version", "-version_memberships", "_artifacts", "arch", "artifacts", "content_ptr", "contentartifact", "context", "dependencies", "group_roles", "name", "packages", "pk", "pulp_created", "pulp_id", "pulp_labels", "pulp_last_updated", "pulp_type", "repositories", "static_context", "stream", "timestamp_of_interest", "upstream_id", "user_roles", "version", "version_memberships"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/rpm/modulemds/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      query_params[:'stream'] = opts[:'stream'] if !opts[:'stream'].nil?
      query_params[:'stream__in'] = @api_client.build_collection_param(opts[:'stream__in'], :csv) if !opts[:'stream__in'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedrpmModulemdResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentModulemdsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a modulemd
    # ViewSet for Modulemd.
    # @param rpm_modulemd_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [RpmModulemdResponse]
    def read(rpm_modulemd_href, opts = {})
      data, _status_code, _headers = read_with_http_info(rpm_modulemd_href, opts)
      data
    end

    # Inspect a modulemd
    # ViewSet for Modulemd.
    # @param rpm_modulemd_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(RpmModulemdResponse, Integer, Hash)>] RpmModulemdResponse data, response status code and response headers
    def read_with_http_info(rpm_modulemd_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentModulemdsApi.read ...'
      end
      # verify the required parameter 'rpm_modulemd_href' is set
      if @api_client.config.client_side_validation && rpm_modulemd_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_modulemd_href' when calling ContentModulemdsApi.read"
      end
      # resource path
      local_var_path = '{rpm_modulemd_href}'.sub('{' + 'rpm_modulemd_href' + '}', CGI.escape(rpm_modulemd_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'RpmModulemdResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentModulemdsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
