=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpRpmClient
  class ContentPackagesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a package
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param relative_path [String] Path where the artifact is located relative to distributions base_path
    # @param [Hash] opts the optional parameters
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [File] :file An uploaded file that may be turned into the artifact of the content unit.
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @option opts [String] :upload An uncommitted upload that may be turned into the artifact of the content unit.
    # @return [AsyncOperationResponse]
    def create(relative_path, opts = {})
      data, _status_code, _headers = create_with_http_info(relative_path, opts)
      data
    end

    # Create a package
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param relative_path [String] Path where the artifact is located relative to distributions base_path
    # @param [Hash] opts the optional parameters
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [File] :file An uploaded file that may be turned into the artifact of the content unit.
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @option opts [String] :upload An uncommitted upload that may be turned into the artifact of the content unit.
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(relative_path, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.create ...'
      end
      # verify the required parameter 'relative_path' is set
      if @api_client.config.client_side_validation && relative_path.nil?
        fail ArgumentError, "Missing the required parameter 'relative_path' when calling ContentPackagesApi.create"
      end
      if @api_client.config.client_side_validation && relative_path.to_s.length < 1
        fail ArgumentError, 'invalid value for "relative_path" when calling ContentPackagesApi.create, the character length must be great than or equal to 1.'
      end

      # resource path
      local_var_path = '/pulp/api/v3/content/rpm/packages/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['relative_path'] = relative_path
      form_params['artifact'] = opts[:'artifact'] if !opts[:'artifact'].nil?
      form_params['file'] = opts[:'file'] if !opts[:'file'].nil?
      form_params['repository'] = opts[:'repository'] if !opts[:'repository'].nil?
      form_params['upload'] = opts[:'upload'] if !opts[:'upload'].nil?

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List packages
    # A ViewSet for Package.  Define endpoint name which will appear in the API endpoint for this content type. For example::     http://pulp.example.com/pulp/api/v3/content/rpm/packages/  Also specify queryset and serializer for Package.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :arch Filter results where arch matches value
    # @option opts [Array<String>] :arch__in Filter results where arch is in a comma-separated list of values
    # @option opts [String] :arch__ne Filter results where arch not equal to value
    # @option opts [String] :checksum_type Filter results where checksum_type matches value
    # @option opts [Array<String>] :checksum_type__in Filter results where checksum_type is in a comma-separated list of values
    # @option opts [String] :checksum_type__ne Filter results where checksum_type not equal to value
    # @option opts [String] :epoch Filter results where epoch matches value
    # @option opts [Array<String>] :epoch__in Filter results where epoch is in a comma-separated list of values
    # @option opts [String] :epoch__ne Filter results where epoch not equal to value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__ne Filter results where name not equal to value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :pkg_id Filter results where pkgId matches value
    # @option opts [Array<String>] :pkg_id__in Filter results where pkgId is in a comma-separated list of values
    # @option opts [String] :release Filter results where release matches value
    # @option opts [Array<String>] :release__in Filter results where release is in a comma-separated list of values
    # @option opts [String] :release__ne Filter results where release not equal to value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :sha256 
    # @option opts [String] :version Filter results where version matches value
    # @option opts [Array<String>] :version__in Filter results where version is in a comma-separated list of values
    # @option opts [String] :version__ne Filter results where version not equal to value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedrpmPackageResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List packages
    # A ViewSet for Package.  Define endpoint name which will appear in the API endpoint for this content type. For example::     http://pulp.example.com/pulp/api/v3/content/rpm/packages/  Also specify queryset and serializer for Package.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :arch Filter results where arch matches value
    # @option opts [Array<String>] :arch__in Filter results where arch is in a comma-separated list of values
    # @option opts [String] :arch__ne Filter results where arch not equal to value
    # @option opts [String] :checksum_type Filter results where checksum_type matches value
    # @option opts [Array<String>] :checksum_type__in Filter results where checksum_type is in a comma-separated list of values
    # @option opts [String] :checksum_type__ne Filter results where checksum_type not equal to value
    # @option opts [String] :epoch Filter results where epoch matches value
    # @option opts [Array<String>] :epoch__in Filter results where epoch is in a comma-separated list of values
    # @option opts [String] :epoch__ne Filter results where epoch not equal to value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__ne Filter results where name not equal to value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :pkg_id Filter results where pkgId matches value
    # @option opts [Array<String>] :pkg_id__in Filter results where pkgId is in a comma-separated list of values
    # @option opts [String] :release Filter results where release matches value
    # @option opts [Array<String>] :release__in Filter results where release is in a comma-separated list of values
    # @option opts [String] :release__ne Filter results where release not equal to value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :sha256 
    # @option opts [String] :version Filter results where version matches value
    # @option opts [Array<String>] :version__in Filter results where version is in a comma-separated list of values
    # @option opts [String] :version__ne Filter results where version not equal to value
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedrpmPackageResponseList, Integer, Hash)>] PaginatedrpmPackageResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.list ...'
      end
      allowable_values = ["md5", "sha1", "sha1", "sha224", "sha256", "sha384", "sha512", "unknown"]
      if @api_client.config.client_side_validation && opts[:'checksum_type'] && !allowable_values.include?(opts[:'checksum_type'])
        fail ArgumentError, "invalid value for \"checksum_type\", must be one of #{allowable_values}"
      end
      allowable_values = ["-_artifacts", "-arch", "-changelogs", "-checksum_type", "-conflicts", "-content_ptr", "-contentartifact", "-description", "-enhances", "-epoch", "-evr", "-files", "-group_roles", "-is_modular", "-location_base", "-location_href", "-name", "-obsoletes", "-pk", "-pkgId", "-provides", "-pulp_created", "-pulp_id", "-pulp_labels", "-pulp_last_updated", "-pulp_type", "-recommends", "-release", "-repositories", "-requires", "-rpm_buildhost", "-rpm_group", "-rpm_header_end", "-rpm_header_start", "-rpm_license", "-rpm_modulemd", "-rpm_packager", "-rpm_sourcerpm", "-rpm_vendor", "-size_archive", "-size_installed", "-size_package", "-suggests", "-summary", "-supplements", "-time_build", "-time_file", "-timestamp_of_interest", "-upstream_id", "-url", "-user_roles", "-version", "-version_memberships", "_artifacts", "arch", "changelogs", "checksum_type", "conflicts", "content_ptr", "contentartifact", "description", "enhances", "epoch", "evr", "files", "group_roles", "is_modular", "location_base", "location_href", "name", "obsoletes", "pk", "pkgId", "provides", "pulp_created", "pulp_id", "pulp_labels", "pulp_last_updated", "pulp_type", "recommends", "release", "repositories", "requires", "rpm_buildhost", "rpm_group", "rpm_header_end", "rpm_header_start", "rpm_license", "rpm_modulemd", "rpm_packager", "rpm_sourcerpm", "rpm_vendor", "size_archive", "size_installed", "size_package", "suggests", "summary", "supplements", "time_build", "time_file", "timestamp_of_interest", "upstream_id", "url", "user_roles", "version", "version_memberships"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/rpm/packages/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'arch'] = opts[:'arch'] if !opts[:'arch'].nil?
      query_params[:'arch__in'] = @api_client.build_collection_param(opts[:'arch__in'], :csv) if !opts[:'arch__in'].nil?
      query_params[:'arch__ne'] = opts[:'arch__ne'] if !opts[:'arch__ne'].nil?
      query_params[:'checksum_type'] = opts[:'checksum_type'] if !opts[:'checksum_type'].nil?
      query_params[:'checksum_type__in'] = @api_client.build_collection_param(opts[:'checksum_type__in'], :csv) if !opts[:'checksum_type__in'].nil?
      query_params[:'checksum_type__ne'] = opts[:'checksum_type__ne'] if !opts[:'checksum_type__ne'].nil?
      query_params[:'epoch'] = opts[:'epoch'] if !opts[:'epoch'].nil?
      query_params[:'epoch__in'] = @api_client.build_collection_param(opts[:'epoch__in'], :csv) if !opts[:'epoch__in'].nil?
      query_params[:'epoch__ne'] = opts[:'epoch__ne'] if !opts[:'epoch__ne'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__ne'] = opts[:'name__ne'] if !opts[:'name__ne'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'pkgId'] = opts[:'pkg_id'] if !opts[:'pkg_id'].nil?
      query_params[:'pkgId__in'] = @api_client.build_collection_param(opts[:'pkg_id__in'], :csv) if !opts[:'pkg_id__in'].nil?
      query_params[:'release'] = opts[:'release'] if !opts[:'release'].nil?
      query_params[:'release__in'] = @api_client.build_collection_param(opts[:'release__in'], :csv) if !opts[:'release__in'].nil?
      query_params[:'release__ne'] = opts[:'release__ne'] if !opts[:'release__ne'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      query_params[:'version'] = opts[:'version'] if !opts[:'version'].nil?
      query_params[:'version__in'] = @api_client.build_collection_param(opts[:'version__in'], :csv) if !opts[:'version__in'].nil?
      query_params[:'version__ne'] = opts[:'version__ne'] if !opts[:'version__ne'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedrpmPackageResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a package
    # A ViewSet for Package.  Define endpoint name which will appear in the API endpoint for this content type. For example::     http://pulp.example.com/pulp/api/v3/content/rpm/packages/  Also specify queryset and serializer for Package.
    # @param rpm_package_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [RpmPackageResponse]
    def read(rpm_package_href, opts = {})
      data, _status_code, _headers = read_with_http_info(rpm_package_href, opts)
      data
    end

    # Inspect a package
    # A ViewSet for Package.  Define endpoint name which will appear in the API endpoint for this content type. For example::     http://pulp.example.com/pulp/api/v3/content/rpm/packages/  Also specify queryset and serializer for Package.
    # @param rpm_package_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(RpmPackageResponse, Integer, Hash)>] RpmPackageResponse data, response status code and response headers
    def read_with_http_info(rpm_package_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.read ...'
      end
      # verify the required parameter 'rpm_package_href' is set
      if @api_client.config.client_side_validation && rpm_package_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_package_href' when calling ContentPackagesApi.read"
      end
      # resource path
      local_var_path = '{rpm_package_href}'.sub('{' + 'rpm_package_href' + '}', CGI.escape(rpm_package_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'RpmPackageResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
