=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpRpmClient
  class PublicationsRpmApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a rpm publication
    # Trigger an asynchronous task to create a new RPM content publication.
    # @param rpm_rpm_publication [RpmRpmPublication] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def create(rpm_rpm_publication, opts = {})
      data, _status_code, _headers = create_with_http_info(rpm_rpm_publication, opts)
      data
    end

    # Create a rpm publication
    # Trigger an asynchronous task to create a new RPM content publication.
    # @param rpm_rpm_publication [RpmRpmPublication] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(rpm_rpm_publication, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PublicationsRpmApi.create ...'
      end
      # verify the required parameter 'rpm_rpm_publication' is set
      if @api_client.config.client_side_validation && rpm_rpm_publication.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_publication' when calling PublicationsRpmApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/publications/rpm/rpm/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(rpm_rpm_publication) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PublicationsRpmApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a rpm publication
    # ViewSet for Rpm Publications.
    # @param rpm_rpm_publication_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(rpm_rpm_publication_href, opts = {})
      delete_with_http_info(rpm_rpm_publication_href, opts)
      nil
    end

    # Delete a rpm publication
    # ViewSet for Rpm Publications.
    # @param rpm_rpm_publication_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(rpm_rpm_publication_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PublicationsRpmApi.delete ...'
      end
      # verify the required parameter 'rpm_rpm_publication_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_publication_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_publication_href' when calling PublicationsRpmApi.delete"
      end
      # resource path
      local_var_path = '{rpm_rpm_publication_href}'.sub('{' + 'rpm_rpm_publication_href' + '}', CGI.escape(rpm_rpm_publication_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PublicationsRpmApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List rpm publications
    # ViewSet for Rpm Publications.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :content Content Unit referenced by HREF
    # @option opts [String] :content__in Content Unit referenced by HREF
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [DateTime] :pulp_created ISO 8601 formatted dates are supported
    # @option opts [DateTime] :pulp_created__gt Filter results where pulp_created is greater than value
    # @option opts [DateTime] :pulp_created__gte Filter results where pulp_created is greater than or equal to value
    # @option opts [DateTime] :pulp_created__lt Filter results where pulp_created is less than value
    # @option opts [DateTime] :pulp_created__lte Filter results where pulp_created is less than or equal to value
    # @option opts [Array<DateTime>] :pulp_created__range Filter results where pulp_created is between two comma separated values
    # @option opts [String] :repository Repository referenced by HREF
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedrpmRpmPublicationResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List rpm publications
    # ViewSet for Rpm Publications.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :content Content Unit referenced by HREF
    # @option opts [String] :content__in Content Unit referenced by HREF
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [DateTime] :pulp_created ISO 8601 formatted dates are supported
    # @option opts [DateTime] :pulp_created__gt Filter results where pulp_created is greater than value
    # @option opts [DateTime] :pulp_created__gte Filter results where pulp_created is greater than or equal to value
    # @option opts [DateTime] :pulp_created__lt Filter results where pulp_created is less than value
    # @option opts [DateTime] :pulp_created__lte Filter results where pulp_created is less than or equal to value
    # @option opts [Array<DateTime>] :pulp_created__range Filter results where pulp_created is between two comma separated values
    # @option opts [String] :repository Repository referenced by HREF
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedrpmRpmPublicationResponseList, Integer, Hash)>] PaginatedrpmRpmPublicationResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PublicationsRpmApi.list ...'
      end
      allowable_values = ["-complete", "-distribution", "-group_roles", "-pass_through", "-pk", "-published_artifact", "-published_metadata", "-pulp_created", "-pulp_id", "-pulp_labels", "-pulp_last_updated", "-pulp_type", "-repository_version", "-rpm_rpmpublication", "-user_roles", "complete", "distribution", "group_roles", "pass_through", "pk", "published_artifact", "published_metadata", "pulp_created", "pulp_id", "pulp_labels", "pulp_last_updated", "pulp_type", "repository_version", "rpm_rpmpublication", "user_roles"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/publications/rpm/rpm/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'content'] = opts[:'content'] if !opts[:'content'].nil?
      query_params[:'content__in'] = opts[:'content__in'] if !opts[:'content__in'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'pulp_created'] = opts[:'pulp_created'] if !opts[:'pulp_created'].nil?
      query_params[:'pulp_created__gt'] = opts[:'pulp_created__gt'] if !opts[:'pulp_created__gt'].nil?
      query_params[:'pulp_created__gte'] = opts[:'pulp_created__gte'] if !opts[:'pulp_created__gte'].nil?
      query_params[:'pulp_created__lt'] = opts[:'pulp_created__lt'] if !opts[:'pulp_created__lt'].nil?
      query_params[:'pulp_created__lte'] = opts[:'pulp_created__lte'] if !opts[:'pulp_created__lte'].nil?
      query_params[:'pulp_created__range'] = @api_client.build_collection_param(opts[:'pulp_created__range'], :csv) if !opts[:'pulp_created__range'].nil?
      query_params[:'repository'] = opts[:'repository'] if !opts[:'repository'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedrpmRpmPublicationResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PublicationsRpmApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a rpm publication
    # ViewSet for Rpm Publications.
    # @param rpm_rpm_publication_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [RpmRpmPublicationResponse]
    def read(rpm_rpm_publication_href, opts = {})
      data, _status_code, _headers = read_with_http_info(rpm_rpm_publication_href, opts)
      data
    end

    # Inspect a rpm publication
    # ViewSet for Rpm Publications.
    # @param rpm_rpm_publication_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(RpmRpmPublicationResponse, Integer, Hash)>] RpmRpmPublicationResponse data, response status code and response headers
    def read_with_http_info(rpm_rpm_publication_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PublicationsRpmApi.read ...'
      end
      # verify the required parameter 'rpm_rpm_publication_href' is set
      if @api_client.config.client_side_validation && rpm_rpm_publication_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_rpm_publication_href' when calling PublicationsRpmApi.read"
      end
      # resource path
      local_var_path = '{rpm_rpm_publication_href}'.sub('{' + 'rpm_rpm_publication_href' + '}', CGI.escape(rpm_rpm_publication_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'RpmRpmPublicationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PublicationsRpmApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
