=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpRpmClient
  class RemotesUlnApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create an uln remote
    # A ViewSet for UlnRemote.
    # @param rpm_uln_remote [RpmUlnRemote] 
    # @param [Hash] opts the optional parameters
    # @return [RpmUlnRemoteResponse]
    def create(rpm_uln_remote, opts = {})
      data, _status_code, _headers = create_with_http_info(rpm_uln_remote, opts)
      data
    end

    # Create an uln remote
    # A ViewSet for UlnRemote.
    # @param rpm_uln_remote [RpmUlnRemote] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(RpmUlnRemoteResponse, Integer, Hash)>] RpmUlnRemoteResponse data, response status code and response headers
    def create_with_http_info(rpm_uln_remote, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesUlnApi.create ...'
      end
      # verify the required parameter 'rpm_uln_remote' is set
      if @api_client.config.client_side_validation && rpm_uln_remote.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_uln_remote' when calling RemotesUlnApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/remotes/rpm/uln/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(rpm_uln_remote) 

      # return_type
      return_type = opts[:return_type] || 'RpmUlnRemoteResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesUlnApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete an uln remote
    # Trigger an asynchronous delete task
    # @param rpm_uln_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(rpm_uln_remote_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(rpm_uln_remote_href, opts)
      data
    end

    # Delete an uln remote
    # Trigger an asynchronous delete task
    # @param rpm_uln_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(rpm_uln_remote_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesUlnApi.delete ...'
      end
      # verify the required parameter 'rpm_uln_remote_href' is set
      if @api_client.config.client_side_validation && rpm_uln_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_uln_remote_href' when calling RemotesUlnApi.delete"
      end
      # resource path
      local_var_path = '{rpm_uln_remote_href}'.sub('{' + 'rpm_uln_remote_href' + '}', CGI.escape(rpm_uln_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesUlnApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List uln remotes
    # A ViewSet for UlnRemote.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [DateTime] :pulp_last_updated ISO 8601 formatted dates are supported
    # @option opts [DateTime] :pulp_last_updated__gt Filter results where pulp_last_updated is greater than value
    # @option opts [DateTime] :pulp_last_updated__gte Filter results where pulp_last_updated is greater than or equal to value
    # @option opts [DateTime] :pulp_last_updated__lt Filter results where pulp_last_updated is less than value
    # @option opts [DateTime] :pulp_last_updated__lte Filter results where pulp_last_updated is less than or equal to value
    # @option opts [Array<DateTime>] :pulp_last_updated__range Filter results where pulp_last_updated is between two comma separated values
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedrpmUlnRemoteResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List uln remotes
    # A ViewSet for UlnRemote.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [DateTime] :pulp_last_updated ISO 8601 formatted dates are supported
    # @option opts [DateTime] :pulp_last_updated__gt Filter results where pulp_last_updated is greater than value
    # @option opts [DateTime] :pulp_last_updated__gte Filter results where pulp_last_updated is greater than or equal to value
    # @option opts [DateTime] :pulp_last_updated__lt Filter results where pulp_last_updated is less than value
    # @option opts [DateTime] :pulp_last_updated__lte Filter results where pulp_last_updated is less than or equal to value
    # @option opts [Array<DateTime>] :pulp_last_updated__range Filter results where pulp_last_updated is between two comma separated values
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedrpmUlnRemoteResponseList, Integer, Hash)>] PaginatedrpmUlnRemoteResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesUlnApi.list ...'
      end
      allowable_values = ["-alternatecontentsource", "-basedistribution", "-ca_cert", "-client_cert", "-client_key", "-connect_timeout", "-distribution", "-download_concurrency", "-group_roles", "-headers", "-max_retries", "-name", "-password", "-pk", "-policy", "-proxy_password", "-proxy_url", "-proxy_username", "-pulp_created", "-pulp_id", "-pulp_labels", "-pulp_last_updated", "-pulp_type", "-rate_limit", "-remoteartifact", "-repository", "-rpm_rpmremote", "-rpm_ulnremote", "-sock_connect_timeout", "-sock_read_timeout", "-tls_validation", "-total_timeout", "-url", "-user_roles", "-username", "alternatecontentsource", "basedistribution", "ca_cert", "client_cert", "client_key", "connect_timeout", "distribution", "download_concurrency", "group_roles", "headers", "max_retries", "name", "password", "pk", "policy", "proxy_password", "proxy_url", "proxy_username", "pulp_created", "pulp_id", "pulp_labels", "pulp_last_updated", "pulp_type", "rate_limit", "remoteartifact", "repository", "rpm_rpmremote", "rpm_ulnremote", "sock_connect_timeout", "sock_read_timeout", "tls_validation", "total_timeout", "url", "user_roles", "username"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/remotes/rpm/uln/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'pulp_label_select'] = opts[:'pulp_label_select'] if !opts[:'pulp_label_select'].nil?
      query_params[:'pulp_last_updated'] = opts[:'pulp_last_updated'] if !opts[:'pulp_last_updated'].nil?
      query_params[:'pulp_last_updated__gt'] = opts[:'pulp_last_updated__gt'] if !opts[:'pulp_last_updated__gt'].nil?
      query_params[:'pulp_last_updated__gte'] = opts[:'pulp_last_updated__gte'] if !opts[:'pulp_last_updated__gte'].nil?
      query_params[:'pulp_last_updated__lt'] = opts[:'pulp_last_updated__lt'] if !opts[:'pulp_last_updated__lt'].nil?
      query_params[:'pulp_last_updated__lte'] = opts[:'pulp_last_updated__lte'] if !opts[:'pulp_last_updated__lte'].nil?
      query_params[:'pulp_last_updated__range'] = @api_client.build_collection_param(opts[:'pulp_last_updated__range'], :csv) if !opts[:'pulp_last_updated__range'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedrpmUlnRemoteResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesUlnApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an uln remote
    # Trigger an asynchronous partial update task
    # @param rpm_uln_remote_href [String] 
    # @param patchedrpm_uln_remote [PatchedrpmUlnRemote] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(rpm_uln_remote_href, patchedrpm_uln_remote, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(rpm_uln_remote_href, patchedrpm_uln_remote, opts)
      data
    end

    # Update an uln remote
    # Trigger an asynchronous partial update task
    # @param rpm_uln_remote_href [String] 
    # @param patchedrpm_uln_remote [PatchedrpmUlnRemote] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(rpm_uln_remote_href, patchedrpm_uln_remote, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesUlnApi.partial_update ...'
      end
      # verify the required parameter 'rpm_uln_remote_href' is set
      if @api_client.config.client_side_validation && rpm_uln_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_uln_remote_href' when calling RemotesUlnApi.partial_update"
      end
      # verify the required parameter 'patchedrpm_uln_remote' is set
      if @api_client.config.client_side_validation && patchedrpm_uln_remote.nil?
        fail ArgumentError, "Missing the required parameter 'patchedrpm_uln_remote' when calling RemotesUlnApi.partial_update"
      end
      # resource path
      local_var_path = '{rpm_uln_remote_href}'.sub('{' + 'rpm_uln_remote_href' + '}', CGI.escape(rpm_uln_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patchedrpm_uln_remote) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesUlnApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect an uln remote
    # A ViewSet for UlnRemote.
    # @param rpm_uln_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [RpmUlnRemoteResponse]
    def read(rpm_uln_remote_href, opts = {})
      data, _status_code, _headers = read_with_http_info(rpm_uln_remote_href, opts)
      data
    end

    # Inspect an uln remote
    # A ViewSet for UlnRemote.
    # @param rpm_uln_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(RpmUlnRemoteResponse, Integer, Hash)>] RpmUlnRemoteResponse data, response status code and response headers
    def read_with_http_info(rpm_uln_remote_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesUlnApi.read ...'
      end
      # verify the required parameter 'rpm_uln_remote_href' is set
      if @api_client.config.client_side_validation && rpm_uln_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_uln_remote_href' when calling RemotesUlnApi.read"
      end
      # resource path
      local_var_path = '{rpm_uln_remote_href}'.sub('{' + 'rpm_uln_remote_href' + '}', CGI.escape(rpm_uln_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'RpmUlnRemoteResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesUlnApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an uln remote
    # Trigger an asynchronous update task
    # @param rpm_uln_remote_href [String] 
    # @param rpm_uln_remote [RpmUlnRemote] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(rpm_uln_remote_href, rpm_uln_remote, opts = {})
      data, _status_code, _headers = update_with_http_info(rpm_uln_remote_href, rpm_uln_remote, opts)
      data
    end

    # Update an uln remote
    # Trigger an asynchronous update task
    # @param rpm_uln_remote_href [String] 
    # @param rpm_uln_remote [RpmUlnRemote] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(rpm_uln_remote_href, rpm_uln_remote, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesUlnApi.update ...'
      end
      # verify the required parameter 'rpm_uln_remote_href' is set
      if @api_client.config.client_side_validation && rpm_uln_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_uln_remote_href' when calling RemotesUlnApi.update"
      end
      # verify the required parameter 'rpm_uln_remote' is set
      if @api_client.config.client_side_validation && rpm_uln_remote.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_uln_remote' when calling RemotesUlnApi.update"
      end
      # resource path
      local_var_path = '{rpm_uln_remote_href}'.sub('{' + 'rpm_uln_remote_href' + '}', CGI.escape(rpm_uln_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(rpm_uln_remote) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesUlnApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
