=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module PulpRpmClient
  # Serializer for Rpm Repositories.
  class PatchedrpmRpmRepository
    attr_accessor :pulp_labels

    # A unique name for this repository.
    attr_accessor :name

    # An optional description.
    attr_accessor :description

    # Retain X versions of the repository. Default is null which retains all versions. This is provided as a tech preview in Pulp 3 and may change in the future.
    attr_accessor :retain_repo_versions

    # An optional remote to use by default when syncing.
    attr_accessor :remote

    # Whether to automatically create publications for new repository versions, and update any distributions pointing to this repository.
    attr_accessor :autopublish

    # A reference to an associated signing service.
    attr_accessor :metadata_signing_service

    # The number of versions of each package to keep in the repository; older versions will be purged. The default is '0', which will disable this feature and keep all versions of each package.
    attr_accessor :retain_package_versions

    # The checksum type for metadata.
    attr_accessor :metadata_checksum_type

    # The checksum type for packages.
    attr_accessor :package_checksum_type

    # An option specifying whether a client should perform a GPG signature check on packages.
    attr_accessor :gpgcheck

    # An option specifying whether a client should perform a GPG signature check on the repodata.
    attr_accessor :repo_gpgcheck

    # An option specifying whether Pulp should generate SQLite metadata.
    attr_accessor :sqlite_metadata

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'pulp_labels' => :'pulp_labels',
        :'name' => :'name',
        :'description' => :'description',
        :'retain_repo_versions' => :'retain_repo_versions',
        :'remote' => :'remote',
        :'autopublish' => :'autopublish',
        :'metadata_signing_service' => :'metadata_signing_service',
        :'retain_package_versions' => :'retain_package_versions',
        :'metadata_checksum_type' => :'metadata_checksum_type',
        :'package_checksum_type' => :'package_checksum_type',
        :'gpgcheck' => :'gpgcheck',
        :'repo_gpgcheck' => :'repo_gpgcheck',
        :'sqlite_metadata' => :'sqlite_metadata'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'pulp_labels' => :'Object',
        :'name' => :'String',
        :'description' => :'String',
        :'retain_repo_versions' => :'Integer',
        :'remote' => :'String',
        :'autopublish' => :'Boolean',
        :'metadata_signing_service' => :'String',
        :'retain_package_versions' => :'Integer',
        :'metadata_checksum_type' => :'MetadataChecksumTypeEnum',
        :'package_checksum_type' => :'PackageChecksumTypeEnum',
        :'gpgcheck' => :'Integer',
        :'repo_gpgcheck' => :'Integer',
        :'sqlite_metadata' => :'Boolean'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'description',
        :'retain_repo_versions',
        :'remote',
        :'metadata_signing_service',
        :'metadata_checksum_type',
        :'package_checksum_type',
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpRpmClient::PatchedrpmRpmRepository` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpRpmClient::PatchedrpmRpmRepository`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'pulp_labels')
        self.pulp_labels = attributes[:'pulp_labels']
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.key?(:'retain_repo_versions')
        self.retain_repo_versions = attributes[:'retain_repo_versions']
      end

      if attributes.key?(:'remote')
        self.remote = attributes[:'remote']
      end

      if attributes.key?(:'autopublish')
        self.autopublish = attributes[:'autopublish']
      else
        self.autopublish = false
      end

      if attributes.key?(:'metadata_signing_service')
        self.metadata_signing_service = attributes[:'metadata_signing_service']
      end

      if attributes.key?(:'retain_package_versions')
        self.retain_package_versions = attributes[:'retain_package_versions']
      end

      if attributes.key?(:'metadata_checksum_type')
        self.metadata_checksum_type = attributes[:'metadata_checksum_type']
      end

      if attributes.key?(:'package_checksum_type')
        self.package_checksum_type = attributes[:'package_checksum_type']
      end

      if attributes.key?(:'gpgcheck')
        self.gpgcheck = attributes[:'gpgcheck']
      else
        self.gpgcheck = 0
      end

      if attributes.key?(:'repo_gpgcheck')
        self.repo_gpgcheck = attributes[:'repo_gpgcheck']
      else
        self.repo_gpgcheck = 0
      end

      if attributes.key?(:'sqlite_metadata')
        self.sqlite_metadata = attributes[:'sqlite_metadata']
      else
        self.sqlite_metadata = false
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@name.nil? && @name.to_s.length < 1
        invalid_properties.push('invalid value for "name", the character length must be great than or equal to 1.')
      end

      if !@description.nil? && @description.to_s.length < 1
        invalid_properties.push('invalid value for "description", the character length must be great than or equal to 1.')
      end

      if !@retain_repo_versions.nil? && @retain_repo_versions < 1
        invalid_properties.push('invalid value for "retain_repo_versions", must be greater than or equal to 1.')
      end

      if !@retain_package_versions.nil? && @retain_package_versions < 0
        invalid_properties.push('invalid value for "retain_package_versions", must be greater than or equal to 0.')
      end

      if !@gpgcheck.nil? && @gpgcheck > 1
        invalid_properties.push('invalid value for "gpgcheck", must be smaller than or equal to 1.')
      end

      if !@gpgcheck.nil? && @gpgcheck < 0
        invalid_properties.push('invalid value for "gpgcheck", must be greater than or equal to 0.')
      end

      if !@repo_gpgcheck.nil? && @repo_gpgcheck > 1
        invalid_properties.push('invalid value for "repo_gpgcheck", must be smaller than or equal to 1.')
      end

      if !@repo_gpgcheck.nil? && @repo_gpgcheck < 0
        invalid_properties.push('invalid value for "repo_gpgcheck", must be greater than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@name.nil? && @name.to_s.length < 1
      return false if !@description.nil? && @description.to_s.length < 1
      return false if !@retain_repo_versions.nil? && @retain_repo_versions < 1
      return false if !@retain_package_versions.nil? && @retain_package_versions < 0
      return false if !@gpgcheck.nil? && @gpgcheck > 1
      return false if !@gpgcheck.nil? && @gpgcheck < 0
      return false if !@repo_gpgcheck.nil? && @repo_gpgcheck > 1
      return false if !@repo_gpgcheck.nil? && @repo_gpgcheck < 0
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] name Value to be assigned
    def name=(name)
      if !name.nil? && name.to_s.length < 1
        fail ArgumentError, 'invalid value for "name", the character length must be great than or equal to 1.'
      end

      @name = name
    end

    # Custom attribute writer method with validation
    # @param [Object] description Value to be assigned
    def description=(description)
      if !description.nil? && description.to_s.length < 1
        fail ArgumentError, 'invalid value for "description", the character length must be great than or equal to 1.'
      end

      @description = description
    end

    # Custom attribute writer method with validation
    # @param [Object] retain_repo_versions Value to be assigned
    def retain_repo_versions=(retain_repo_versions)
      if !retain_repo_versions.nil? && retain_repo_versions < 1
        fail ArgumentError, 'invalid value for "retain_repo_versions", must be greater than or equal to 1.'
      end

      @retain_repo_versions = retain_repo_versions
    end

    # Custom attribute writer method with validation
    # @param [Object] retain_package_versions Value to be assigned
    def retain_package_versions=(retain_package_versions)
      if !retain_package_versions.nil? && retain_package_versions < 0
        fail ArgumentError, 'invalid value for "retain_package_versions", must be greater than or equal to 0.'
      end

      @retain_package_versions = retain_package_versions
    end

    # Custom attribute writer method with validation
    # @param [Object] gpgcheck Value to be assigned
    def gpgcheck=(gpgcheck)
      if !gpgcheck.nil? && gpgcheck > 1
        fail ArgumentError, 'invalid value for "gpgcheck", must be smaller than or equal to 1.'
      end

      if !gpgcheck.nil? && gpgcheck < 0
        fail ArgumentError, 'invalid value for "gpgcheck", must be greater than or equal to 0.'
      end

      @gpgcheck = gpgcheck
    end

    # Custom attribute writer method with validation
    # @param [Object] repo_gpgcheck Value to be assigned
    def repo_gpgcheck=(repo_gpgcheck)
      if !repo_gpgcheck.nil? && repo_gpgcheck > 1
        fail ArgumentError, 'invalid value for "repo_gpgcheck", must be smaller than or equal to 1.'
      end

      if !repo_gpgcheck.nil? && repo_gpgcheck < 0
        fail ArgumentError, 'invalid value for "repo_gpgcheck", must be greater than or equal to 0.'
      end

      @repo_gpgcheck = repo_gpgcheck
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          pulp_labels == o.pulp_labels &&
          name == o.name &&
          description == o.description &&
          retain_repo_versions == o.retain_repo_versions &&
          remote == o.remote &&
          autopublish == o.autopublish &&
          metadata_signing_service == o.metadata_signing_service &&
          retain_package_versions == o.retain_package_versions &&
          metadata_checksum_type == o.metadata_checksum_type &&
          package_checksum_type == o.package_checksum_type &&
          gpgcheck == o.gpgcheck &&
          repo_gpgcheck == o.repo_gpgcheck &&
          sqlite_metadata == o.sqlite_metadata
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [pulp_labels, name, description, retain_repo_versions, remote, autopublish, metadata_signing_service, retain_package_versions, metadata_checksum_type, package_checksum_type, gpgcheck, repo_gpgcheck, sqlite_metadata].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        PulpRpmClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
